/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	パスワード暗号／複合クラス
//			変更履歴
//				2004.01.08	新規作成
//
package jp.co.ntt.lms.xmo.util;

import java.lang.*;
import java.io.*;

/**
 * パスワード暗号化／復号化クラス
 * @author 
 * @version 
 */
public class RmsKPassword {
	
	/**
	 * パスワード暗号化処理
	 * @param String パスワード
	 * @return String 暗号パスワード
	 */
	public static String GetEncodePassword( String strPasswd )
	{
		// △入力パスワードがnull／サイズ０、である
		if ( strPasswd == null || strPasswd.length() == 0  )
		{
			return strPasswd;
		}
		byte[] bytPasswd = strPasswd.getBytes();
		
		int[]	intEncPasswd = new int[bytPasswd.length];
		byte[]	bytEncPasswd = new byte[bytPasswd.length];
		// ○暗号化パスワード(bytEncPasswd)をサイズ分NULLクリア
		for(int i=0; i<bytPasswd.length; i++){
			 intEncPasswd[i] = 0x00000000;
			 bytEncPasswd[i] = 0x00;
		}
		
		// ○入力パスワードを暗号化する。
		for (int i = 0; i < bytPasswd.length; i++)
		{
			intEncPasswd[i] = ( bytPasswd[i] << 1 ) ^ 0x000000ff;
			bytEncPasswd[i] = new Integer(intEncPasswd[i]).byteValue();
		}
		String result;
		try{
			result = DataConverter.byteArrayToBase64String(bytEncPasswd);
			result = result.trim();
		} catch( Exception e ){
			e.printStackTrace();
			return "";
		}
		
		return result;
	}

	/**
	 * パスワード復号化処理
	 * @param String 暗号パスワード
	 * @return String 復号パスワード
	 */
	public static String GetDecordPassword(String strPasswd)
	{

		// △暗号パスワードがnull／サイズ０、である
		if ( strPasswd == null || strPasswd.length() == 0 )
		{
			return strPasswd;
		}
		strPasswd = strPasswd.trim();
		byte[] bytPasswd;
		try{
			bytPasswd = DataConverter.base64StringToByteArray( strPasswd );
		} catch( Exception e ){
			e.printStackTrace();
			return "";
		}
		int[]	intRevPasswd = new int[bytPasswd.length];
		byte[]	bytRevPasswd = new byte[bytPasswd.length];
		// ○復号化パスワード(bytPasswd)をサイズ(*lpdwSize)分NULLクリア
		for(int i=0; i<bytPasswd.length; i++){
			 intRevPasswd[i] = 0x00000000;
			bytRevPasswd[i] = 0x00;
		}

		// ○取得した暗号化パスワードを復号化する。
		for ( int i = 0; i < bytPasswd.length; i++ )
		{
			if ( bytPasswd[i] == 0x00)
			{
				break;
			}
			intRevPasswd[i] = (( bytPasswd[i] ^ 0xff ) >>> 1) & 0x0000007f;
			bytRevPasswd[i] = new Integer(intRevPasswd[i]).byteValue();
		} 
		return new String(bytRevPasswd);
	}
}
